# Genesis Foundation UI App/Workspace Generator

This repo contains our **xgen** tool for automated generation of applications and workspaces from seeds.
It's intended for testing and CI use. Unlike `genx` / `foundation-cli`, it's not aimed at end users.

It only works with local seeds (so authentication step is not needed).

Features:
* combines input with configure step defaults - you only need to supply parameters with no default values
* prints out combined parameter data for verification
* validates input using configure step validators
* automatically detects the generator to use with ability to override
* doesn't overwrite data - exits if target directory already exists

```sh
Usage:
      xgen myapp gpl-seed # current folder
      xgen myapp ./subfolder/my-seed # relative path
      xgen myapp gpl-seed --apiHost 'ws://custom-url/gwf/'
      xgen myapp blank-app-seed --pkgName foo
      xgen myapp workspace-seed 'create workspace' # explicitly choosing the generator
      xgen myapp workspace-seed 'create workspace' --parameter 'value'
```

[![lerna](https://img.shields.io/badge/maintained%20with-lerna-cc00ff.svg)](https://lerna.js.org/)
[![TypeScript](https://img.shields.io/badge/%3C%2F%3E-TypeScript-%230074c1.svg)](https://www.typescriptlang.org/)

## License

Note: this project provides front end dependencies and uses licensed components listed in the next section, thus licenses for those components are required during development. Contact [Genesis Global](https://genesis.global/contact-us/) for more details.

### Licensed components
Genesis low-code platform